pub use adw::prelude::*;
pub use adw::subclass::prelude::*;

pub use papers_document::prelude::*;
pub use papers_view::prelude::*;

pub use papers_document::Document;
pub use papers_document::DocumentInfo;
pub use papers_document::DocumentLayers;
pub use papers_document::DocumentLinks;
pub use papers_document::DocumentSignatures;
pub use papers_document::DocumentText;
pub use papers_view::DocumentModel;
pub use papers_view::JobLinks;
pub use papers_view::JobThumbnailTexture;

pub use gtk::CompositeTemplate;
pub use gtk::TemplateChild;

pub use gtk::gdk;
pub use gtk::gio;
pub use gtk::glib;
pub use gtk::graphene;

pub use glib::subclass::InitializingObject;
pub use glib::subclass::Signal;
pub use glib::Properties;
pub use glib::SignalHandlerId;

pub use std::cell::RefCell;

pub use std::cmp::min;

pub use gettextrs::gettext;

pub use std::sync::OnceLock;

pub use log::{debug, warn};

pub use crate::config::*;
pub use crate::i18n::gettext_f;
pub use crate::i18n::gettext_fd;
pub use crate::window::WindowRunMode;

// All widget types
pub use crate::annotation_properties_dialog::PpsAnnotationPropertiesDialog;
pub use crate::application::PpsApplication;
pub use crate::document_view::PpsDocumentView;
pub use crate::file_monitor::PpsFileMonitor;
pub use crate::find_sidebar::PpsFindSidebar;
pub use crate::loader_view::PpsLoaderView;
pub use crate::page_selector::PpsPageSelector;
pub use crate::password_view::PpsPasswordView;
pub use crate::progress_message_area::PpsProgressMessageArea;
pub use crate::properties_fonts::PpsPropertiesFonts;
pub use crate::properties_general::PpsPropertiesGeneral;
pub use crate::properties_license::PpsPropertiesLicense;
pub use crate::properties_signatures::PpsPropertiesSignatures;
pub use crate::properties_window::PpsPropertiesWindow;
pub use crate::search_box::PpsSearchBox;
pub use crate::sidebar::PpsSidebar;
pub use crate::sidebar_annotations::PpsSidebarAnnotations;
pub use crate::sidebar_annotations_row::PpsSidebarAnnotationsRow;
pub use crate::sidebar_attachments::PpsSidebarAttachments;
pub use crate::sidebar_layers::PpsSidebarLayers;
pub use crate::sidebar_links::PpsSidebarLinks;
pub use crate::sidebar_page::{PpsSidebarPage, PpsSidebarPageExt, PpsSidebarPageImpl};
pub use crate::sidebar_thumbnails::PpsSidebarThumbnails;
pub use crate::stack_switcher::PpsStackSwitcher;
pub use crate::thumbnail_item::PpsThumbnailItem;
pub use crate::window::PpsWindow;
